"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = require("react");

var _createReactContext2 = _interopRequireDefault(require("create-react-context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

/* eslint-disable react/no-multi-comp */
var wrapConsumer = function wrapConsumer(Consumer, _ref) {
  var _consumerConstruct = _ref.consumerConstruct,
      _consumerProps = _ref.consumerProps,
      _consumerCtx = _ref.consumerCtx;

  var MutextConsumer =
  /*#__PURE__*/
  function (_Component) {
    _inheritsLoose(MutextConsumer, _Component);

    function MutextConsumer(props) {
      var _this;

      _this = _Component.call(this, props) || this;

      _this.consumerConstruct(_assertThisInitialized(_this));

      return _this;
    }

    var _proto = MutextConsumer.prototype;

    _proto.consumerConstruct = function consumerConstruct(consumer) {
      if (_consumerConstruct) _consumerConstruct(consumer);
    };

    _proto.consumerProps = function consumerProps(props, consumer) {
      return _consumerProps ? _consumerProps(props, consumer) : props;
    };

    _proto.consumerCtx = function consumerCtx(ctx, consumer) {
      return _consumerCtx ? _consumerCtx(ctx, consumer) : ctx;
    };

    _proto.render = function render() {
      var _this2 = this;

      var props = this.consumerProps(this.props, this);
      return (0, _react.createElement)(Consumer, _objectSpread({}, props, {
        // children: ctx => this.consumerCtx(ctx, this),
        children: function children(ctx) {
          return props.children(_this2.consumerCtx(ctx, _this2));
        }
      }));
    };

    return MutextConsumer;
  }(_react.Component);

  return MutextConsumer;
};

var createMutableContext = function createMutableContext(confDefaultValue, calcChangedBits, option) {
  if (option === void 0) {
    option = {};
  }

  var _createReactContext = (0, _createReactContext2.default)(confDefaultValue, calcChangedBits),
      Provider = _createReactContext.Provider,
      Consumer = _createReactContext.Consumer;

  var _option = option,
      providerConstruct = _option.providerConstruct;

  var MutextProvider =
  /*#__PURE__*/
  function (_Component2) {
    _inheritsLoose(MutextProvider, _Component2);

    function MutextProvider(props) {
      var _this3;

      _this3 = _Component2.call(this, props) || this;

      _initialiseProps.call(_assertThisInitialized(_this3));

      var value = [props.value, props.defaultValue, confDefaultValue].find(function (a) {
        return a !== undefined;
      });
      var state = _this3.getStateFromValue(value) || {};
      state.set = _this3.set;
      _this3.state = state;
      if (providerConstruct) providerConstruct(_assertThisInitialized(_this3));
      return _this3;
    }

    var _proto2 = MutextProvider.prototype;

    _proto2.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        this.setState(this.getStateFromValue(nextProps.value));
      }
    }; // allow override to change ctx to value relationship


    _proto2.getStateFromValue = function getStateFromValue(value) {
      // prevent overwrite set or enhanced functions? in componentWillReceiveProps
      return value;
    };

    _proto2.getStateUpdater = function getStateUpdater(updater) {
      // prevent overwrite set or enhanced functions? in set function
      return updater;
    };

    _proto2.render = function render() {
      return (0, _react.createElement)(Provider, {
        value: this.state
      }, this.props.children);
    };

    return MutextProvider;
  }(_react.Component);

  var _initialiseProps = function _initialiseProps() {
    var _this4 = this;

    Object.defineProperty(this, "set", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(newValue, callback) {
        var _this4$props = _this4.props,
            value = _this4$props.value,
            onChange = _this4$props.onChange; // this is Uncontrolled

        if (value === undefined) _this4.setState(_this4.getStateUpdater(newValue), callback); // always fire onChange for persist usage

        if (onChange) onChange(newValue, callback);
      }
    });
  };

  return {
    Provider: MutextProvider,
    Consumer: wrapConsumer(Consumer, option)
  };
};

var _default = createMutableContext;
exports.default = _default;