"use strict";

require("raf/polyfill");

var _react = _interopRequireDefault(require("react"));

var _enzyme = _interopRequireWildcard(require("enzyme"));

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

var _createMutableContext = _interopRequireDefault(require("./createMutableContext"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

_enzyme.default.configure({
  adapter: new _enzymeAdapterReact.default()
});

var Indirection =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Indirection, _React$Component);

  function Indirection() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Indirection.prototype;

  _proto.shouldComponentUpdate = function shouldComponentUpdate() {
    return false;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return Indirection;
}(_react.default.Component);

test('basic', function () {
  var C = (0, _createMutableContext.default)({
    foo: 1
  });

  var App = function App() {
    return _react.default.createElement(C.Provider, null, _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, null, function (ctx) {
      return _react.default.createElement("button", {
        onClick: function onClick() {
          return ctx.set({
            foo: ctx.foo + 1
          });
        }
      }, ctx.foo);
    })));
  };

  var button = (0, _enzyme.mount)(_react.default.createElement(App, null)).find('button');
  expect(button.text()).toBe('1');
  button.simulate('click');
  expect(button.text()).toBe('2');
});
test('controlled', function () {
  var calcChangeA;
  var calcChangeB;
  var C = (0, _createMutableContext.default)(null, function (a, b) {
    calcChangeA = a;
    calcChangeB = b;
    return 1023;
  });

  var App = function App(props) {
    return _react.default.createElement(C.Provider, {
      value: {
        foo: props.foo
      }
    }, _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, null, function (ctx) {
      return _react.default.createElement("span", {
        prop: "Foo: " + ctx.foo
      });
    })));
  };

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(App, {
    foo: 1
  }));
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 1"
  }))).toBe(true);
  wrapper.setProps({
    foo: 2
  });
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 2"
  }))).toBe(true);
  expect(calcChangeA).toMatchObject({
    foo: 1
  });
  expect(calcChangeB).toMatchObject({
    foo: 2
  });
});
test('enhancer', function () {
  var C1 = (0, _createMutableContext.default)({
    foo: 1
  }, null, {
    providerConstruct: function providerConstruct(provider) {
      provider.state.inc1 = function () {
        return provider.set(function (prev) {
          return {
            foo: prev.foo + 1
          };
        });
      };
    }
  });

  var App = function App() {
    return _react.default.createElement(C1.Provider, null, _react.default.createElement(C1.Consumer, null, function (ctx) {
      return _react.default.createElement("button", {
        id: "btn1",
        onClick: ctx.inc1
      }, ctx.foo);
    }));
  };

  var wrap = (0, _enzyme.mount)(_react.default.createElement(App, null));
  var btn1 = wrap.find('#btn1');
  expect(btn1.text()).toBe('1');
  btn1.simulate('click');
  expect(btn1.text()).toBe('2');
});