"use strict";

exports.__esModule = true;
exports.default = void 0;

var _createMutableContext2 = _interopRequireDefault(require("./createMutableContext"));

var _getBitmaskTable = _interopRequireDefault(require("./getBitmaskTable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MAX_SIGNED_31_BIT_INT = 1073741823;

var parseNames = function parseNames(nameStr) {
  return nameStr.split(/\s*,\s*/);
};

var noop = function noop() {};

var createObservableMutext = function createObservableMutext(preload, tableConfs, option) {
  if (option === void 0) {
    option = {};
  }

  var tableNames = Object.keys(tableConfs).sort();
  var bitmaskTable = (0, _getBitmaskTable.default)(tableNames);

  var calcChangedBits = function calcChangedBits(a, b) {
    var result = tableNames.reduce(function (r, name) {
      // eslint-disable-next-line no-bitwise
      return a[name] !== b[name] ? r | bitmaskTable[name] : r;
    }, 0); // changed on somethings that not in names

    return result === 0 && a !== b ? MAX_SIGNED_31_BIT_INT : result;
  };

  var getObservedBits = function getObservedBits(observe) {
    // observe should be string to recognition
    return parseNames(observe).reduce(function (r, name) {
      // eslint-disable-next-line no-bitwise
      return r | bitmaskTable[name];
    }, 0);
  };

  var _createMutableContext = (0, _createMutableContext2.default)(preload, calcChangedBits, _objectSpread({}, option, {
    // ensure wrap consumer
    consumerConstruct: option.consumerConstruct || noop
  })),
      Provider = _createMutableContext.Provider,
      Consumer = _createMutableContext.Consumer;

  var ObservableConsumer =
  /*#__PURE__*/
  function (_Consumer) {
    _inheritsLoose(ObservableConsumer, _Consumer);

    function ObservableConsumer() {
      var _temp, _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (_temp = _this = _Consumer.call.apply(_Consumer, [this].concat(args)) || this, Object.defineProperty(_assertThisInitialized(_this), "observedBits", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: getObservedBits(_this.props.observe)
      }), _temp) || _assertThisInitialized(_this);
    }

    var _proto = ObservableConsumer.prototype;

    _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      if (this.props.observe !== nextProps.observe) {
        this.observedBits = getObservedBits(nextProps.observe);
      }
    };

    _proto.consumerProps = function consumerProps(props, consumer) {
      props = _Consumer.prototype.consumerProps.call(this, props, consumer);
      props = _objectSpread({}, props, {
        observedBits: consumer.observedBits
      });
      return props;
    };

    return ObservableConsumer;
  }(Consumer);

  return {
    Provider: Provider,
    Consumer: ObservableConsumer
  };
};

var _default = createObservableMutext;
exports.default = _default;