"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = _interopRequireWildcard(require("enzyme"));

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

var _createObservableMutext = _interopRequireDefault(require("./createObservableMutext"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

_enzyme.default.configure({
  adapter: new _enzymeAdapterReact.default()
});

var Indirection =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Indirection, _React$Component);

  function Indirection() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Indirection.prototype;

  _proto.shouldComponentUpdate = function shouldComponentUpdate() {
    return false;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return Indirection;
}(_react.default.Component);

test('can skip consumers with bitmask', function () {
  var renders = {
    Foo: 0,
    Bar: 0,
    BarOrFoo: 0
  };
  var C = (0, _createObservableMutext.default)({
    foo: 0,
    bar: 0
  }, {
    foo: {},
    bar: {}
  });

  var App = function App(props) {
    return _react.default.createElement(C.Provider, {
      value: {
        foo: props.foo,
        bar: props.bar
      }
    }, _react.default.createElement(Indirection, null, _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, {
      observe: "foo"
    }, function (ctx) {
      renders.Foo += 1;
      return _react.default.createElement("span", {
        prop: "Foo: " + ctx.foo
      });
    })), _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, {
      observe: "bar"
    }, function (ctx) {
      renders.Bar += 1;
      return _react.default.createElement("span", {
        prop: "Bar: " + ctx.bar
      });
    })), _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, {
      observe: "bar,foo"
    }, function (ctx) {
      renders.BarOrFoo += 1;
      return _react.default.createElement("span", {
        prop: "BarOrFoo: " + ctx.bar + " " + ctx.foo
      });
    }))));
  };

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(App, {
    foo: 1,
    bar: 1
  }));
  expect(renders.Foo).toBe(1);
  expect(renders.Bar).toBe(1);
  expect(renders.BarOrFoo).toBe(1);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 1"
  }), _react.default.createElement("span", {
    prop: "Bar: 1"
  }))).toBe(true); // Update only foo

  wrapper.setProps({
    foo: 2,
    bar: 1
  });
  expect(renders.Foo).toBe(2);
  expect(renders.Bar).toBe(1);
  expect(renders.BarOrFoo).toBe(2);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 2"
  }), _react.default.createElement("span", {
    prop: "Bar: 1"
  }))).toBe(true); // Update only bar

  wrapper.setProps({
    bar: 2,
    foo: 2
  });
  expect(renders.Foo).toBe(2);
  expect(renders.Bar).toBe(2);
  expect(renders.BarOrFoo).toBe(3);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 2"
  }), _react.default.createElement("span", {
    prop: "Bar: 2"
  }))).toBe(true); // Update both

  wrapper.setProps({
    bar: 3,
    foo: 3
  });
  expect(renders.Foo).toBe(3);
  expect(renders.Bar).toBe(3);
  expect(renders.BarOrFoo).toBe(4);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 3"
  }), _react.default.createElement("span", {
    prop: "Bar: 3"
  })));
});