"use strict";

exports.__esModule = true;
exports.default = exports.wrapUpdaterScope = void 0;

var _createMutableContext2 = _interopRequireDefault(require("./createMutableContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var wrapUpdaterScope = function wrapUpdaterScope(updater, stateKey) {
  var _ref2;

  return typeof updater === 'function' ? function (prevState, props) {
    var _ref;

    return _ref = {}, _ref[stateKey] = updater(prevState[stateKey], props), _ref;
  } : (_ref2 = {}, _ref2[stateKey] = updater, _ref2);
};

exports.wrapUpdaterScope = wrapUpdaterScope;

var createValueMutext = function createValueMutext(confDefaultValue, calcChangedBits) {
  var _createMutableContext = (0, _createMutableContext2.default)(confDefaultValue, calcChangedBits ? function (_ref3, _ref4) {
    var a = _ref3.value;
    var b = _ref4.value;
    return calcChangedBits(a, b);
  } : undefined),
      Provider = _createMutableContext.Provider,
      Consumer = _createMutableContext.Consumer;

  var ValueMutextProvider =
  /*#__PURE__*/
  function (_Provider) {
    _inheritsLoose(ValueMutextProvider, _Provider);

    function ValueMutextProvider() {
      return _Provider.apply(this, arguments) || this;
    }

    var _proto = ValueMutextProvider.prototype;

    _proto.getStateFromValue = function getStateFromValue(value) {
      return {
        value: value
      };
    };

    _proto.getStateUpdater = function getStateUpdater(updater) {
      return wrapUpdaterScope(updater, 'value');
    };

    return ValueMutextProvider;
  }(Provider);

  return {
    Provider: ValueMutextProvider,
    Consumer: Consumer
  };
};

var _default = createValueMutext;
exports.default = _default;