"use strict";

exports.__esModule = true;
exports.Indirection = void 0;

require("raf/polyfill");

var _react = _interopRequireDefault(require("react"));

var _enzyme = _interopRequireWildcard(require("enzyme"));

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

var _createValueMutext3 = _interopRequireWildcard(require("./createValueMutext"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

_enzyme.default.configure({
  adapter: new _enzymeAdapterReact.default()
});

var Indirection =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Indirection, _React$Component);

  function Indirection() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Indirection.prototype;

  _proto.shouldComponentUpdate = function shouldComponentUpdate() {
    return false;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return Indirection;
}(_react.default.Component);

exports.Indirection = Indirection;
test('basic', function () {
  var _createValueMutext = (0, _createValueMutext3.default)(),
      Provider = _createValueMutext.Provider,
      Consumer = _createValueMutext.Consumer;

  var Child =
  /*#__PURE__*/
  function (_React$Component2) {
    _inheritsLoose(Child, _React$Component2);

    function Child() {
      return _React$Component2.apply(this, arguments) || this;
    }

    var _proto2 = Child.prototype;

    _proto2.shouldComponentUpdate = function shouldComponentUpdate() {
      return false;
    };

    _proto2.render = function render() {
      return _react.default.createElement(Consumer, null, function (ctx) {
        return _react.default.createElement("button", {
          onClick: function onClick() {
            return ctx.set(ctx.value + 1);
          }
        }, ctx.value);
      });
    };

    return Child;
  }(_react.default.Component);

  var dom = _react.default.createElement(Provider, {
    defaultValue: 1
  }, _react.default.createElement(Child, null));

  var button = (0, _enzyme.mount)(dom).find('button');
  expect(button.text()).toBe('1');
  button.simulate('click');
  expect(button.text()).toBe('2');
});
test('onChange', function () {
  var _createValueMutext2 = (0, _createValueMutext3.default)(),
      Provider = _createValueMutext2.Provider,
      Consumer = _createValueMutext2.Consumer;

  var App =
  /*#__PURE__*/
  function (_React$Component3) {
    _inheritsLoose(App, _React$Component3);

    function App() {
      var _temp, _this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (_temp = _this = _React$Component3.call.apply(_React$Component3, [this].concat(args)) || this, Object.defineProperty(_assertThisInitialized(_this), "state", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {
          valueA: 1
        }
      }), _temp) || _assertThisInitialized(_this);
    }

    var _proto3 = App.prototype;

    _proto3.render = function render() {
      var _this2 = this;

      return _react.default.createElement(Provider, {
        value: this.state.valueA,
        onChange: function onChange(updater, callback) {
          return _this2.setState((0, _createValueMutext3.wrapUpdaterScope)(updater, 'valueA'), callback);
        }
      }, _react.default.createElement(Consumer, null, function (ctx) {
        return _react.default.createElement("button", {
          onClick: function onClick() {
            return ctx.set(function (prevValue) {
              return prevValue + 1;
            });
          }
        }, ctx.value);
      }));
    };

    return App;
  }(_react.default.Component);

  var button = (0, _enzyme.mount)(_react.default.createElement(App, null)).find('button');
  expect(button.text()).toBe('1');
  button.simulate('click');
  expect(button.text()).toBe('2');
});
test('can skip consumers with bitmask', function () {
  var renders = {
    Foo: 0,
    Bar: 0
  };
  var C = (0, _createValueMutext3.default)({
    foo: 0,
    bar: 0
  }, function (a, b) {
    var result = 0;
    if (a.foo !== b.foo) result |= 1;
    if (a.bar !== b.bar) result |= 2;
    return result;
  });

  function App(props) {
    return _react.default.createElement(C.Provider, {
      value: {
        foo: props.foo,
        bar: props.bar
      }
    }, _react.default.createElement(Indirection, null, _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, {
      observedBits: 1
    }, function (_ref) {
      var value = _ref.value;
      renders.Foo += 1;
      return _react.default.createElement("span", {
        prop: "Foo: " + value.foo
      });
    })), _react.default.createElement(Indirection, null, _react.default.createElement(C.Consumer, {
      observedBits: 2
    }, function (_ref2) {
      var value = _ref2.value;
      renders.Bar += 1;
      return _react.default.createElement("span", {
        prop: "Bar: " + value.bar
      });
    }))));
  }

  var wrapper = (0, _enzyme.mount)(_react.default.createElement(App, {
    foo: 1,
    bar: 1
  }));
  expect(renders.Foo).toBe(1);
  expect(renders.Bar).toBe(1);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 1"
  }), _react.default.createElement("span", {
    prop: "Bar: 1"
  }))).toBe(true); // Update only foo

  wrapper.setProps({
    foo: 2,
    bar: 1
  });
  expect(renders.Foo).toBe(2);
  expect(renders.Bar).toBe(1);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 2"
  }), _react.default.createElement("span", {
    prop: "Bar: 1"
  }))).toBe(true); // Update only bar

  wrapper.setProps({
    bar: 2,
    foo: 2
  });
  expect(renders.Foo).toBe(2);
  expect(renders.Bar).toBe(2);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 2"
  }), _react.default.createElement("span", {
    prop: "Bar: 2"
  }))).toBe(true); // Update both

  wrapper.setProps({
    bar: 3,
    foo: 3
  });
  expect(renders.Foo).toBe(3);
  expect(renders.Bar).toBe(3);
  expect(wrapper.contains(_react.default.createElement("span", {
    prop: "Foo: 3"
  }), _react.default.createElement("span", {
    prop: "Bar: 3"
  })));
});